unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, OleCtrls, CortonaVRMLClientLibrary_TLB, StdCtrls,
  FileCtrl, inifiles, Menus, ComCtrls, Buttons, ImgList, ToolWin,ShellAPI,
  ActnList,Strutils;

type
  TForm1 = class(TForm)
    Cortona1: TCortona;
    Panel1: TPanel;
    Splitter1: TSplitter;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    ListBox1: TListBox;
    Panel2: TPanel;
    Splitter2: TSplitter;
    StatusBar1: TStatusBar;
    Panel3: TPanel;
    Panel4: TPanel;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ActionList1: TActionList;
    Action1: TAction;
    Timer1: TTimer;
    Action2: TAction;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Cortona1FrameRateMeasured(ASender: TObject; fps: Single);
    procedure Cortona1SceneLoaded(ASender: TObject; Success: WordBool);
    Procedure WMSyscommand(Var msg: TWmSysCommand); message WM_SYSCOMMAND;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Action2Execute(Sender: TObject);
  private
    procedure WMDROPFILES(var Msg: TMessage);
    procedure LBWindowProc(var Message: TMessage);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  dir,cesta:string;
  OldWindowProc : Pointer; {Variable for the old windows proc}
  MyMsg : DWord; {custom systemwide message}
  fps_soucet,fps_soucet_10:single;
  fps_pole:array [1..10] of single;
  fps_pocet:integer;
  OldLBWindowProc: TWndMethod;
  cas:ttime;

implementation

{$R *.dfm}

procedure nacti_scenu(a:string);
begin
    a:=ansireplacestr(a,'file://','');
    form1.cortona1.Scene:=a;
    try
      form1.drivecombobox1.Drive:=a[1];
      form1.directorylistbox1.Directory:=a;
    except
    end;
end;

procedure tform1.WMSyscommand(var msg: TWmSysCommand);
begin
   Case (msg.cmdtype and $FFF0) of

       SC_MAXIMIZE: Begin
            form1.WindowState:=wsMaximized;
            panel1.Visible:= false;
            panel4.Visible:= false;
            msg.result := 0;

       end;
       SC_RESTORE: Begin
            form1.WindowState:=wsNormal;
            panel1.Visible:= true;
            panel4.Visible:= true;
            msg.result := 0;
       end;

       Else
           inherited;
   end;
end;




function NewWindowProc(WindowHandle : hWnd;
                       TheMessage   : LongInt;
                       ParamW       : LongInt;
                       ParamL       : LongInt) : LongInt stdcall;
var Zprava: array [0..1024] of char;
var text:string;
begin
  if TheMessage = MyMsg  then begin
    application.Minimize;
    application.Restore;
    GlobalGetAtomName(ParamW, Zprava, SizeOf(Zprava));
    text:=zprava;
    if length(text)>0 then begin
      nacti_scenu(text);
    end;
    Result := 0;
    exit;
  end;

  Result := CallWindowProc(OldWindowProc,
                           WindowHandle,
                           TheMessage,
                           ParamW,
                           ParamL);
end;


procedure TForm1.WMDROPFILES(var Msg: TMessage);
var
  pcFileName: PChar;
   iSize: integer;
begin
  iSize := DragQueryFile(Msg.wParam, 0, nil, 0) + 1;
  pcFileName := StrAlloc(iSize);
  DragQueryFile(Msg.wParam, 0, pcFileName, iSize);
  if FileExists(pcFileName) then nacti_scenu(pcFileName);
  StrDispose(pcFileName);
  DragFinish(Msg.wParam);
end;




procedure TForm1.DriveComboBox1Change(Sender: TObject);
begin
    directorylistbox1.Drive:=drivecombobox1.Drive;
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
var
    sr:tsearchrec;
begin
    listbox1.Clear;
    dir:=directorylistbox1.Directory;
    if dir[length(dir)]<>'\' then dir:=dir+'\';
    if FindFirst(dir+'*.wrl', faanyfile, sr) = 0 then
    begin
      repeat
        listbox1.AddItem(sr.Name,nil);
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;

end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
    cortona1.Scene:=dir+listbox1.Items[listbox1.ItemIndex];
end;


procedure TForm1.LBWindowProc(var Message: TMessage);
begin
  if Message.Msg = WM_DROPFILES then
    WMDROPFILES(Message); // handle WM_DROPFILES message
  OldLBWindowProc(Message);
  // call default ListBox1 WindowProc method to handle all other messages
end;



procedure TForm1.FormCreate(Sender: TObject);
var ini:tinifile;
begin
    cesta:=extractfilepath(application.ExeName);
    MyMsg := RegisterWindowMessage('VRMLbrowser');
    OldWindowProc := Pointer(SetWindowLong(Form1.Handle,
                                         GWL_WNDPROC,
                                         LongInt(@NewWindowProc)));

    DragAcceptFiles(cortona1.Handle,true);
    OldLBWindowProc := cortona1.WindowProc; // store defualt WindowProc
    cortona1.WindowProc := LBWindowProc; // replace default WindowProc
    DragAcceptFiles(ListBox1.Handle, True); // now ListBox1 accept dropped files



    ini:=tinifile.Create(cesta+'VRMLbrowser.ini');
    form1.Height:=ini.ReadInteger('Okno','Vyska',form1.Height);
    form1.width:=ini.ReadInteger('Okno','Sirka',form1.width);
    form1.left:=ini.ReadInteger('Okno','Vlevo',form1.left);
    form1.top:=ini.ReadInteger('Okno','Nahore',form1.top);
    panel1.width:=ini.ReadInteger('Okno','Explorer',180);
    ini.Free;
    cortona1.NavigationMode:=3;
    if paramcount>0 then begin
      nacti_scenu(paramstr(1));
    end;
    DirectoryListBox1Change(nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var ini:tinifile;
begin
   ini:=tinifile.Create(cesta+'VRMLbrowser.ini');
   ini.WriteInteger('Okno','Vyska',form1.Height);
   ini.WriteInteger('Okno','Sirka',form1.width);
   ini.WriteInteger('Okno','Vlevo',form1.left);
   ini.WriteInteger('Okno','Nahore',form1.top);
   ini.WriteInteger('Okno','Explorer',panel1.Width);
   ini.UpdateFile;
   ini.Free;

   cortona1.WindowProc := OldLBWindowProc;
    DragAcceptFiles(cortona1.Handle, False);

    SetWindowLong(Form1.Handle,GWL_WNDPROC,LongInt(OldWindowProc));
end;


procedure TForm1.Cortona1FrameRateMeasured(ASender: TObject; fps: Single);
begin
    statusbar1.Panels[0].Text:=format('Te je %.2f fps',[fps]);

    fps_soucet:=fps_soucet+fps;
    inc(fps_pocet);
    statusbar1.Panels[1].Text:=format('Prmr je %.2f fps',[fps_soucet/fps_pocet]);

    fps_soucet_10:=fps_soucet_10 - fps_pole[(fps_pocet mod 10)+1] + fps;
    fps_pole[(fps_pocet mod 10)+1]:=fps;
    statusbar1.Panels[2].Text:=format('Prmr za 10s je %.2f fps',[fps_soucet_10/10]);
end;

procedure TForm1.Cortona1SceneLoaded(ASender: TObject; Success: WordBool);
var i:integer;
begin
    fps_soucet:=0;
    fps_pocet:=0;
    for i:=1 to 10 do fps_pole[i]:=0;
    form1.Caption:='VRMLbrowser - '+ansireplacestr(cortona1.Scene,'file://','');
    cas:=time();
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    if form1.WindowState=wsmaximized then action:=caNone;
    form1.WindowState:=wsnormal;
    panel1.Visible:= true;
    
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
    cortona1.Freeze:=toolbutton1.Down;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin

    if (cortona1.RendererHints and 512) > 0 then cortona1.RendererHints:=cortona1.RendererHints-512 else
    cortona1.RendererHints:=cortona1.RendererHints+512;
    if (cortona1.RendererHints and 32768) > 0 then cortona1.RendererHints:=cortona1.RendererHints-32768 else
    cortona1.RendererHints:=cortona1.RendererHints+32768;
end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
     if (cortona1.RendererHints and 256) > 0 then cortona1.RendererHints:=cortona1.RendererHints-256 else
    cortona1.RendererHints:=cortona1.RendererHints+256;
end;

procedure TForm1.Action1Execute(Sender: TObject);
begin
    toolbutton1.Down:=false;
    ToolButton1Click(nil);
    nacti_scenu(cortona1.Scene);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var hodina,minuta,sekunda,msekunda:word;
begin
    decodetime(time()-cas,hodina,minuta,sekunda,msekunda);
    statusbar1.Panels[3].Text:=format('as je %.2d:%.2d:%.2d.%.3d',[hodina,minuta,sekunda,msekunda]);
end;

procedure TForm1.Action2Execute(Sender: TObject);
begin
    showmessage(inttostr(cortona1.RendererHints));
end;

end.
